hdu 1426 Sudoku Killer ( Dancing Link 精确覆盖 )

利用 Dancing Link 来解数独

具体的可以看    lrj 的训练指南 和 《 Dancing Links 在搜索中的应用 》这篇论文

Dancing Link 来求解数独 , 是通过求解精确覆盖

精确覆盖就是给出一个 01 矩阵 , 要求我们选择一些行 , 使得每一列有且仅有一个 1

对于数独问题 , 行就是我们的选择 , 即在第 i 行 第 j 列 放上 数字 k , 所以我们最多有 i * j * k 中选择

如果某些位置( x , y  )已经放了数字 a , 那么我们的选择只能是 ( x , y , a ) , 否则的话, 我们可以选择 ( x , y , 1 ~ 9 )

对于列 , 也就是我们需要满足的条件 , 这里有 4 大类条件:

1. 第 x 行 第 y 列要有 数字

2. 第 x 行 要有 数字 y

3. 第 x 列 要有 数字 y

4. 第 x 个宫要有数字 y

所以总共有 9*9*4 列 ( 假设 9*9*4 的数独的话 )

然后我们只要进行DLX就行了

#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <vector>
using namespace std;

const int maxn = 9 * 9 * 4 + 10 ;
const int maxr = 9 * 9 * 9 + 10 ;
const int maxnode = maxr * 4 + maxr + 10 ;

#define FOR( i , A , s ) for( int i = A[s] ; i != s ; i = A[i] ) 

struct DLX{
    // maxn 列数 , maxnode 总节点数 , maxr 行数
    int n , sz ;
    int S[maxn] ; 

    int row[maxnode] , col[maxnode] ;
    int L[maxnode] , R[maxnode] , U[maxnode] , D[maxnode] ;
    int H[maxr] ;

    int ansd , ans[maxr] ;

    void init( int N ) {
        n = N ;
        // 第一行的虚拟结点
        for( int i = 0 ; i <= n ; i ++ ) {
            U[i] = D[i] = i ;
            L[i] = i - 1 ;
            R[i] = i + 1 ;
        }
        R[n] = 0 ; L[0] = n ;
        sz = n + 1 ;
		// 每一列的个数
        memset( S , 0 , sizeof(S) ) ;
		// H[i] = -1 表示这一行还没有 1
		// 否则表示第一个 1 的 sz 是多少
        memset( H , -1 , sizeof(H)) ;
    }

    // 在第r行第c列添加一个1
    void Link( int r , int c ) {
        row[sz] = r ;
        col[sz] = c ;
        S[c] ++ ;

        D[sz] = c ; U[sz] = U[c] ;
        D[U[c]] = sz ; U[c] = sz ;

        if( H[r] < 0 ) { H[r] = L[sz] = R[sz] = sz ; }
        else{
            R[sz] = H[r] ;
            L[sz] = L[H[r]] ;
            R[L[sz]] = sz ;
            L[R[sz]] = sz ;
        }

        sz ++ ;

    }

    // 删除 第 c 列
    void remove ( int c ) {
        // 删除虚拟结点中的 c 列
        L[R[c]] = L[c] ;
        R[L[c]] = R[c] ;
        // 从 c 列向下遍历
        FOR( i , D , c ) {
            // 删除遍历到的行
            FOR( j , R , i ) {
                D[U[j]] = D[j] ;
                U[D[j]] = U[j] ;
                -- S[col[j]] ;
            }
        }
    }

    // 恢复第 c 列
    void restore( int c ) {
        FOR( i , U , c ) {
            FOR( j , L , i ) {
                ++S[col[j]] ;
                U[D[j]] = D[U[j]] = j ;
            }
        }
        L[R[c]] = R[L[c]] = c ;
    }

    bool dfs( int d ) {
		// 如果已经没有列了 , 算法结束
        if( R[0] == 0 ) {
            ansd = d ;
            return true ;
        }

        // 找到 s 最小的列 , 加快搜索的速度
        int c = R[0] ;
        FOR( i , R , 0 ) {
            if( S[i] < S[c] ) c = i ;
        }

        // 删除第 c 列
        remove( c ) ;

		// 遍历选中列中有1的行
        FOR( i , D , c ) {
            ans[d] = row[i] ;
			// 删除选中行中有1的列
            FOR( j , R , i ) {
                remove( col[j] ) ;
            }
            if( dfs( d + 1 ) ) return true ;
			// 回复删除掉的列
            FOR( j , L , i ) {
                restore( col[j] ) ;
            }
        }
        restore( c ) ;
        return false ;
    }

    bool solve() {
        if( !dfs(0) ) return false ;
        return true ;
    }
} dlx ;

int ans[15][15] ;

const int SLOT = 0 ;
const int ROW  = 1 ;
const int COL  = 2 ;
const int SUB  = 3 ;

inline int encode (  int a , int b , int c ) {
    return a * 9 * 9 + b * 9 + c + 1 ;
}

int main(){
    char str[5] ;
    int casn =  0 ;
    while( scanf( "%s" , str ) != EOF ) {

        if( str[0] == '?' ) {
            ans[0][0] = 0 ;
        }else{
            ans[0][0] = str[0] - '0' ;
        }
        for( int i = 0 ; i < 9 ; i ++ ) {
            for( int j = 0 ; j < 9 ; j ++ ) {
                if( i == 0 && j == 0 ) continue ;
                scanf( "%s" , str ) ;
                if( str[0] == '?' )
                    ans[i][j] = 0 ;
                else
                    ans[i][j] = str[0] - '0' ;
            }
        }

        if( casn ++ ) {
            puts( "" ) ;
        }

        dlx.init( 9 * 9 * 4 ) ;

        for( int i = 0 ; i < 9 ; i ++ ) {
            for( int j = 0 ; j < 9 ; j ++ ) {
                for( int k = 0 ; k < 9 ; k ++ ) {
                    int rr = encode( i , j , k ) ;
                    if( ans[i][j] == 0 || ans[i][j] == k + 1 ) {
                        dlx.Link( rr , encode( SLOT , i , j ) ) ;
                        dlx.Link( rr , encode( ROW  , i , k ) ) ;
                        dlx.Link( rr , encode( COL  , j , k ) ) ;
                        dlx.Link( rr , encode( SUB  , ( i / 3 ) * 3 + j / 3 , k ) ) ;

                    }
                }
            }
        }

        dlx.solve() ;
        for( int i = 0 ; i < dlx.ansd ; i ++ ) {
            int r , c , v ;
            int t = dlx.ans[i] ;
            t -- ;
            v = t % 9 ;
            t /= 9 ;
            c = t % 9 ;
            t /= 9 ;
            r = t ;
            ans[r][c] = v + 1 ;
        }
        for( int i = 0 ; i < 9 ; i ++ ) {
            for( int j = 0 ; j < 9 ; j ++ ) {
                printf( j == 8 ?"%d\n" : "%d " , ans[i][j] ) ;
            }
        }
    }
    return 0 ;
}
时间: 2024-10-21 04:26:25

hdu 1426 Sudoku Killer ( Dancing Link 精确覆盖 )的相关文章

HDU 1426 Sudoku Killer(dfs 解数独)

传送门: http://acm.hdu.edu.cn/showproblem.php?pid=1426 Sudoku Killer Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 9804    Accepted Submission(s): 2944 Problem Description 自从2006年3月10日至11日的首届数独世界

HDU 1426 Sudoku Killer(数独,划分区域是关键)

Sudoku Killer Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6283    Accepted Submission(s): 1981 Problem Description 自从2006年3月10日至11日的首届数独世界锦标赛以后,数独这项游戏越来越受到人们的喜爱和重视. 据说,在2008北京奥运会上,会将数独列为一个单

hdu 1426 Sudoku Killer

题目:http://acm.hdu.edu.cn/showproblem.php?pid=1426 1 #include<stdio.h> 2 #include<math.h> 3 #include<string.h> 4 #include<stdlib.h> 5 #include<iostream> 6 using namespace std; 7 char map[12][12]; 8 bool row[12][12],list[12][12

HDU 1426 Sudoku Killer【DFS 数独】

自从2006年3月10日至11日的首届数独世界锦标赛以后,数独这项游戏越来越受到人们的喜爱和重视. 据说,在2008北京奥运会上,会将数独列为一个单独的项目进行比赛,冠军将有可能获得的一份巨大的奖品———HDU免费七日游外加lcy亲笔签名以及同hdu acm team合影留念的机会. 所以全球人民前仆后继,为了奖品日夜训练茶饭不思.当然也包括初学者linle,不过他太笨了又没有多少耐性,只能做做最最基本的数独题,不过他还是想得到那些奖品,你能帮帮他吗?你只要把答案告诉他就可以,不用教他是怎么做的

hdu 1426 Sudoku Killer(DFS)

1 #include <iostream> 2 #include <memory.h> 3 #include <vector> 4 #include <string> 5 #include <cstdio> 6 using namespace std; 7 8 int row[11][11],col[11][11],blo[11][11],mp[11][11]; 9 struct node{ 10 int x,y; 11 }; 12 node u

HDU 1426 Sudoku Killer DFS 简单题

给出一个数独的一部分,然后然后要我们填完整这个数独. Input 本题包含多组测试,每组之间由一个空行隔开.每组测试会给你一个 9*9 的矩阵,同一行相邻的两个元素用一个空格分开.其中1-9代表该位置的已经填好的数,问号(?)表示需要你填的数. Output 对于每组测试,请输出它的解,同一行相邻的两个数用一个空格分开.两组解之间要一个空行.对于每组测试数据保证它有且只有一个解. Sample Input 7 1 2 ? 6 ? 3 5 8 ? 6 5 2 ? 7 1 ? 4 ? ? 8 5 1

HDU 1426 Sudoku Killer (回溯 + 剪枝)

题意: 给你一个 9*9 的矩阵,同一行相邻的两个元素用一个空格分开.其中1-9代表该位置的已经填好的数,问号(?)表示需要你填的数.输出这个数独的解,每组有且只有一个解. 思路: 记录下空缺的地方,每个空缺的地方有 9 中状态,DFS + 剪枝处理其他的,用scanf进行输入,gets() TLE到死.... 代码: #include <cstdio> #include <iostream> #include <cstring> #include <cstrin

hust 1017 dancing links 精确覆盖模板题

最基础的dancing links的精确覆盖题目 1 #include <iostream> 2 #include <cstring> 3 #include <cstdio> 4 #include <algorithm> 5 6 using namespace std; 7 #define N 1005 8 #define MAXN 1000100 9 10 struct DLX{ 11 int n , m , size;//size表示当前dlx表中有多少

ZOJ 3209 Treasure Map (Dancing Links 精确覆盖 )

题意 :  给你一个大小为 n * m 的矩形 , 坐标是( 0 , 0 ) ~ ( n , m )  .然后给你 p 个小矩形 , 坐标是( x1 , y1 ) ~ ( x2 , y2 ) , 你选择最小的几个矩形 , 使得这些矩形可以覆盖整个矩形 , 并且互相不会重叠 .( n , m <= 30 ) 思路 : Dancing Links 的精确覆盖问题 . 我们将 n * m 的矩形分成 n * m 个小正方形 ,那么我们只要保证每个小正方形被覆盖且只被覆盖一次即可 . 那么列表示每个小正